{&Use32+}
Uses
 Objects, rStrings, rObjects, rFidoMsg, rOpen, rAbs, rCommon, Dos, OpCrt;

var
 msg: pAbsMsg;
 base: pAbsBase;
 oc: pStringCollection;
 s,fn,fm: String;
 sr: SearchRec;
 f: pStream;
 m,x: Longint;

procedure ProcessPacket(name: String);
 var
  s: String;
  i: Integer;
 begin
  Write('processing packet ['+name+']... ');
  if not Exist(name) then
   begin
    WriteLn('failed!');
    exit;
   end;
  Base:=OpenOrCreateBase('p'+name,stDenyWrite);
  if Base=nil then
   begin
    WriteLn('failed!');
    exit;
   end;
  New(Msg,Init);
  for x:=1 to Base^.Count do if Base^.LoadMsg(Msg^,x)=0 then if Msg^.AbsMsgData.Origin<>'' then
   begin
    s:=Trim(Msg^.AbsMsgData.Origin,SpaceChars);
    if s='' then s:=' ';
    if not oc^.Search(@s,i) then oc^.Insert(NewStr(s));
   end;

  DisposeObj(Msg);
  DisposeObj(Base);
  WriteLn('done!');
 end;

begin
 m:=MemFucked;
 WriteLn;
 WriteLn('raVen''s origin extractor v0.2 (c) 2000 by raVen');
 WriteLn;
 if (ParamCount<>2) then
  begin
   WriteLn('usage: roe.exe pktmask textfile');
   Halt(1);
  end;
 fm:=ParamStr(1);
 fn:=ParamStr(2);
 New(oc,Init(16,16));
 if (Exist(fn)) then
  begin
   Write('loading prev. origins... ');
   f:=New(pBufStream,Init(fn,stOpenRead,BlockSize));
   repeat
    StreamReadLn(f^,s);
    if s<>'' then oc^.Insert(NewStr(Trim(s,SpaceChars)));
   until (f^.Status<>stOK) or (f^.GetPos=f^.GetSize);
   DisposeObj(f);
   WriteLn('done!');
  end;
 FindFirst(fm,AnyFile,sr);
 while DosError=0 do
  begin
   ProcessPacket(AddBackSlash(JustPathName(fm))+sr.Name);
   FindNext(sr);
  end;
{$IfDef VirtualPascal}
 FindClose(sr);
{$EndIf}
 Write('storing origins... ');
 f:=New(pBufStream,Init(fn,stCreate,BlockSize));
 if oc^.Count>0 then for x:=0 to oc^.Count-1 do
  StreamWriteLn(f^,GetPS(oc^.At(x)),cr+lf);
 WriteLn('done!');
 DisposeObj(f);
 DisposeObj(oc);
 Delay(66);
 WriteLn('memory leak - ',MemFucked);
end.
